module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = __webpack_require__(3);


/***/ },
/* 1 */
/***/ function(module, exports) {

	'use strict';
	'use strcit';

	// Flow types

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

	exports.length = length;
	exports.minLength = minLength;
	exports.maxLength = maxLength;
	exports.match = match;
	exports.min = min;
	exports.max = max;
	exports.oneOf = oneOf;
	exports.empty = empty;


	// Checks if number is equal to length
	function length(num) {
	  return function (data) {
	    if (data.length !== num) {
	      throw new Error('Length Error: ' + data + ' length is not equal to ' + num);
	    }
	    return data;
	  };
	}

	// Checks if number is not less than minimum length
	function minLength(num) {
	  return function (data) {
	    if (data.length < num) {
	      throw new Error('Length Error: ' + data + ' length is less than to ' + num);
	    }

	    return data;
	  };
	}

	// Checks if number is not more than the maximun length
	function maxLength(num) {
	  return function (data) {
	    if (data.length > num) {
	      throw new Error('Length Error: ' + data + ' length is more than to ' + num);
	    }

	    return data;
	  };
	}

	// Checks if string matches reqex
	function match(re) {
	  return function (data) {

	    if (!data.match(re)) {
	      throw new Error('Match Validator Error: ' + data + ' does not match regex}');
	    }
	    return data;
	  };
	}

	// Checks if number is not less than minimum number
	function min(num) {
	  return function (data) {
	    if (data < num) {
	      throw new Error('Min Validator Error: ' + data + ' is less than ' + num);
	    }

	    return data;
	  };
	}

	// Checks if number is not more than maximum number
	function max(num) {
	  return function (data) {
	    if (data > num) {
	      throw new Error('Max Validator Error: ' + data + ' is more than ' + num);
	    }

	    return data;
	  };
	}

	// Checks if data is one of the enum elements
	function oneOf(list) {
	  return function (data) {
	    if (!list.includes(data)) {
	      throw new Error('One of Validator Error: ' + data + ' is not one of [' + list + ']');
	    }

	    return data;
	  };
	}

	// Checks if data is one of the enum elements
	function empty(empty) {
	  return function (data) {

	    var throwEmpty = function throwEmpty(value) {
	      throw new Error('Empty Validator Error: Property cannot be empty');
	    };

	    if (typeof empty === 'boolean') {
	      var dataType = typeof data === 'undefined' ? 'undefined' : _typeof(data);

	      if (dataType === 'string' && !data || data.trim === '') throwEmpty();
	      if (dataType === 'number' && data === 0) throwEmpty();
	      if (Array.isArray(data) && data.length === 0) throwEmpty('Array');
	    }

	    return data;
	  };
	}

/***/ },
/* 2 */
/***/ function(module, exports) {

	'use strict';
	'use strcit';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.default = customValidation;
	function customValidation(middleWare) {
	  return function (data) {

	    var reducer = function reducer(value, fn) {
	      if (Array.isArray(value)) {
	        return value.map(function (el) {
	          return fn(el);
	        });
	      } else {
	        var valid = fn(value);

	        if (valid.error) {
	          throw new Error(valid.error);
	        } else {
	          return fn(value);
	        }
	      }
	    };

	    var pipe = function pipe(fns) {
	      return function (current) {
	        return fns.reduce(reducer, current);
	      };
	    };

	    return pipe(middleWare)(data);
	  };
	}

/***/ },
/* 3 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

	exports.default = isSchemaValid;

	var _customValidation = __webpack_require__(2);

	var _customValidation2 = _interopRequireDefault(_customValidation);

	var _builtInValidators = __webpack_require__(1);

	var builtInValidators = _interopRequireWildcard(_builtInValidators);

	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	// check object structure matches Collection schema


	// Flow types
	function keyValidation(type) {
	  if (type == null) {
	    throw new TypeError('Schema Key Error: A key is not a undefined.');
	  }
	}

	// check all object pairs values have the correst typeof as stated in Collection Schema
	function valueValidation(data, key, schemaType) {
	  var type = schemaType.type;
	  var length = schemaType.length;
	  var empty = schemaType.empty;
	  var minLength = schemaType.minLength;
	  var maxLength = schemaType.maxLength;
	  var max = schemaType.max;
	  var min = schemaType.min;
	  var match = schemaType.match;
	  var oneOf = schemaType.oneOf;


	  builtInValidators.empty(empty)(data);

	  // type validation
	  if (schemaType.type === 'array') {

	    // if array call isSchema to validate nested array.
	    data.forEach(function (element) {
	      return isSchemaValid(element, schemaType.schema);
	    });
	  } else if ((typeof data === 'undefined' ? 'undefined' : _typeof(data)) !== type) {
	    throw new TypeError('Schema Value Error: ' + key + ' value is not ' + type + ' type.');
	  }

	  oneOf && builtInValidators.oneOf(oneOf)(data);

	  // string validation
	  if (type === 'string') {
	    length && builtInValidators.length(length)(data);
	    maxLength && builtInValidators.maxLength(maxLength)(data);
	    minLength && builtInValidators.minLength(minLength)(data);
	    match && builtInValidators.match(match)(data);
	  }

	  // number validation
	  if (type === 'number') {
	    max && builtInValidators.max(max)(data);
	    min && builtInValidators.min(min)(data);
	  }
	}

	// check object has all requireds fields in the Collection schema
	function requiredValidation(data, fields) {
	  fields.forEach(function (item) {
	    if (data[item] === undefined) {
	      throw new Error('Schema Required Field Error: Required field ' + item + ' is missing.');
	    }
	  });
	}

	// validate all elements in the Collection
	function keyAndPairValidation(data, schema, requiredFields) {
	  requiredValidation(data, requiredFields);

	  if ((typeof data === 'undefined' ? 'undefined' : _typeof(data)) === 'object') {
	    Object.keys(data).forEach(function (key) {

	      if (schema[key] != null && _typeof(schema[key].type) === 'object') {
	        var nestedData = data[key];
	        var nestedSchema = schema[key].type;
	        var nestedRequiredFields = getRequiredFields(nestedSchema);

	        if (Array.isArray(schema[key].type)) {

	          valueValidation(data[key], key, _extends({}, schema[key], { type: 'array' }));
	        }

	        return keyAndPairValidation(nestedData, nestedSchema, nestedRequiredFields);
	      }

	      var schemaType = void 0;

	      if (Array.isArray(schema[key])) {
	        schemaType = { type: 'array', schema: schema[key][0] };

	        // run custom validation
	        schema[key][0].validation && (0, _customValidation2.default)(schema[key][0].validation)(data[key]);
	      } else if (_typeof(schema[key]) === 'object') {
	        schemaType = schema[key].type ? schema[key] : { type: 'object' };

	        // run custom validation
	        schema[key].validation && (0, _customValidation2.default)(schema[key].validation)(data[key]);
	      } else {

	        schemaType = Array.isArray(schema) ? { type: 'object' } : { type: schema[key] };
	      }

	      keyValidation(schemaType.type);
	      valueValidation(data[key], key, schemaType);
	    });
	  } else {
	    // if element is not an object

	    valueValidation(data, 'array', { type: schema });
	  }
	}

	// extract required fields from Collection schema
	function getRequiredFields(schema) {
	  return Object.keys(schema).map(function (key) {
	    if (schema[key].required === true) return key;
	  }).filter(function (items) {
	    return items;
	  });
	}

	// validate schema
	function isSchemaValid(schema) {
	  return function (data) {
	    var requiredFields = getRequiredFields(schema);

	    try {
	      keyAndPairValidation(data, schema, requiredFields);
	      return { valid: true };
	    } catch (error) {
	      return {
	        valid: false,
	        name: error.name,
	        message: error.message,
	        stack: error.stack
	      };
	    }
	  };
	}

/***/ }
/******/ ]);